#include "sugi.h"

#define CONFIG_FILE "book.cfg"
#define ONSEI_DIC   "onsei.dic"

#define MIN_HORIZON     2
#define MAX_HORIZON     668     /*  }EXEJ[\̍s͈  */
#define MAX_HORIZON2    639     /*  XN[o[\  */
#define MIN_VERTICAL    2
#define MAX_VERTICAL    470

#define wrt(str,x,y,for_c,back_c,fsiz) \
         wrtstr(str,writepage,(((x)>>1)+((y)<<9)),cct[for_c],cct[back_c],fsiz)

#define PAGE0   0               /*  CAO  */
#define PAGE1   0x40000         /*  CAP  */

#define CHR_COL     10          /*  eLXgʂ̕F  */
#define BAK_COL     8           /*  eLXgʂ̔wiF  */
#define CR_COL      9           /*  eLXgʂ̉sF  */
#define CTRL_COL    11          /*  eLXgʂ̐䕶F  */

#define _CHR_COL    0xAAAAAAAA   /*  eLXgʂ̕F  */
#define _BAK_COL    0x88888888   /*  eLXgʂ̔wiF  */
#define _CR_COL     0x99999999   /*  eLXgʂ̉sF  */
#define _CTRL_COL   0xBBBBBBBB   /*  eLXgʂ̐F  */

#define STD_COL     15          /*  EBhD̕F  */
#define WIND_COL    5           /*  EBhD̔wiF  */
#define BOX1_COL    7           /*  EBhD̍F  */
#define BOX2_COL    1           /*  EBhD̉EF  */
#define BTN_COL     4           /*  I{^̐F  */

#define WHITE_h     15
#define WHITE_l     7
#define BLACK_h     3
#define BLACK_l     1
#define BLACK       BLACK_l
#define HIT_COL     6

#define TAB_DEF 8       /* ftHgEn[hE^uԊu */
#define TAB_SML 4       /* k^u */
#define TAB_NOT 0       /* ^uWJȂ */

#define X_DOTOFS    4               /* ʂ̍[̃ItZbg(dot P) */
#define X_OFFSET    (X_DOTOFS/2)    /* ʂ̍[̃ItZbg(byteP) */

#define XMIN (X_DOTOFS)
#define XMAX (639+X_DOTOFS)

#define MODE_PSET   0
#define MODE_XOR    4




/*  snd.c  */
extern  int     snd_play(char *file);

/*  wc.c  */
extern  void    wc_init(void);
extern  int     wc_apend(char *name, int mode);
extern  char    *file_select(int enable_cancel);

/*  bin.c  */
extern  int     snd_str(int y, char *str, int len);
extern  int     init_tree(char *file);

/*  vram.asm  */
extern int      wrtstr(char *, int, int, int, int, int);
extern void     ctblset(int chr, int bak);
extern void     putstr(int adr, char *str, int len, char *str);
extern void     dsp_adr_set(int startaddr);

/*  screen.c  */
extern  void    cls(int page, int color);
extern  void    wide_screen(int);
extern  void    vertical_screen(int lines); /* \C */
extern  void    dsp_box(int,int, int,int, int forc,int bakc,int boxc);
extern  void    dsp_box_clip(int,int, int,int, int forc,int bakc,int boxc);
extern  void    DSP_getBlock(int x,int y, int xsiz,int ysiz, char *ptn);
extern  void    DSP_putBlock(int x,int y, int xsiz,int ysiz, char *ptn);
extern  void    DSP_ptnColor(int x,int y, int xsiz,int ysiz, char *, int);
extern  void    box(int,int, int,int, int,int,int);
extern  void    pbox(int,int, int,int, int,int);
extern  void    cls(int page, int color);    /* ʃNA */
extern  void    set_palette(int color, int b, int r, int g);
extern  void    DSP_writePage(char *work, int page);
extern  void    box2(int x1,int y1, int x2,int y2, int color1,int color2);
extern  void    wait_vsync(void);

/*  setup.asm  */
extern  int     ESR_setupInfo(char *out_buf);

/*  book.c  */
extern  void    init_screen(void);
extern  void    dsp_line(int y, char *buf, int bytes);
extern  int     get_nowline(void);      /* ݂̕\sʒm */
extern  int     redisp_lnum(void);      /* sԍ\ */
extern  int     calc_pos(char *str, int pos);
extern  void    title_backup(int sw);   /* ^CgCޔ^ */
extern  int     set_auto_scroll(int value);
extern  void    unset_auto_scroll(void);

/* debug.c */
extern  void    prt(int x,int y, char *form,...);
extern  void    fprt(char *path, char *form,...);



/*
 *  global variables
*/

extern  const   char    *version ;      /*  book v#.##  */
extern  const   char    *_version ;     /*  book v#.###  */
extern  const   char    *date ;         /*  Aug 14 1992  */
extern  const   char    *timestamp ;    /*  00:00:00  */
extern          char    *config ;       /*  pathlist for config  */

extern  int     errno;

extern  int     page_ofs;
extern  int     writepage;
extern  char    gwork[EgbWorkSize];
extern  const   cct[16];
extern  int     mos_disp_off;
extern  u_char  char_to_sc[];
extern  u_char  sc_to_char[];

extern  short   max_horizon;
extern  short   can_use_snd;

extern  char    dev_icn[8][60];     /* efoCXpACR 32*15dot */
extern  char    drv_icn[26][26];    /* ehCupACR 16*13dot */
extern  char    ptn_door[];         /* ĨhAEACR */
extern  char    ptn_file[];         /* t@CZN^EACR */
extern  char    ptn_snd[];          /* ǂݏグ{^ */

